PREADE ;	READ PENCIL FILE & DUMP TO SCREEN
 	ORG	07000H
 START	LD	HL,BUFFER	;I/O AREA
 	PUSH	HL
 	LD	DE,BUFFER+1
 	LD	A,20H
 	LD	(HL),A
 	LD	BC,255
 	LDIR
 	POP	HL
 	LD	BC,00		;SET LRL = 256
 	LD	(LREC),BC
 	LD	DE,DCB		;FILESPEC
 	XOR	A
 	CALL	4424H		;OPEN FILE
 	JP	NZ,402DH	;ABORT IF FILE NOT THERE
 	LD	HL,(DCB+12)	;END REC. NO.
 	LD	(REC),HL
 	INC	HL
 	LD	(LREC),HL
 	LD	DE,STORE
 	PUSH	DE
 READ:	LD	DE,DCB		;PULL IN TEXT
 	CALL	4436H		;GET RECORD
 	JR	NZ,BAD
 	LD	HL,BUFFER
 	POP	DE
 	LD	BC,256
 	LDIR
 	PUSH	DE
 	LD	BC,(REC)
 	DEC	BC
 	LD	A,B
 	OR	C
 	JR	Z,CLOSE
 	LD	(REC),BC
 	JR	READ
 CLOSE:	LD	DE,DCB
 	CALL	4428H
 	JR	Z,DOIT
 BAD:	JP	402DH
 DOIT:	CALL	01C9H
 	LD	DE,STORE
 	LD	HL,(4020H)
 PRT:	LD	BC,(LREC)
 	LD	A,B
 	OR	C
 	JR	Z,DONE
 	DEC	BC
 	LD	(LREC),BC
 	LD	BC,256
 PRT1A:	LD	A,(DE)
 	CP	'%'
 	JR	Z,DONE
 	CP	0DH
 	JR	Z,CTRL
 	LD	(HL),A
 	CP	(HL)
 	JR	Z,OK
 	SUB	20H
 	LD	(HL),A
 OK:	INC	HL
 	INC	DE
 	DEC	BC
 	LD	A,B
 	OR	C
 	JR	Z,PRT
 	LD	A,H
 	CP	3FH		;LAST LINE TO USE
 	CALL	Z,WAIT
 	JR	PRT1A
 CTRL:	CALL	033AH
 	LD	HL,(4020H)
 	DEC	HL
 	JR	OK
 WAIT:	LD	A,L
 	CP	80H
 	RET	C
 	PUSH	HL
 	PUSH	DE
 	PUSH	BC
 	LD	DE,WMSG
 	LD	HL,3FC0H
 	LD	BC,LMSG
 PRT1:	LD	A,(DE)
 	LD	(HL),A
 	CP	(HL)
 	JR	Z,OK1
 	SUB	20H
 	LD	(HL),A
 OK1:	INC	HL
 	INC	DE
 	DEC	BC
 	LD	A,B
 	OR	C
 	JR	NZ,PRT1
 	CALL	FLASH
 	POP	BC
 	POP	DE
 	POP	HL
 	CALL	01C9H
 	LD	HL,(4020H)
 	RET
 DONE:	LD	DE,DMSG
 	LD	HL,3FC0H
 	LD	BC,DMLEN
 PRT2:	LD	A,(DE)
 	LD	(HL),A
 	CP	(HL)
 	JR	Z,OK2
 	SUB	20H
 	LD	(HL),A
 OK2	INC	HL
 	INC	DE
 	DEC	BC
 	LD	A,B
 	OR	C
 	JR	NZ,PRT2
 	CALL	FLASH
 	LD	HL,OMSG	;EXECUTE "DIR"
 	PUSH	HL
 	LD	DE,4318H
 	LD	BC,LENO
 	LDIR
 	POP	HL
 	JP	4405H
 FLASH:	PUSH	HL
 	PUSH	BC
 	INC	HL
 FL1:	LD	A,'#'
 	LD	(HL),A
 	LD	BC,17FFH
 	CALL	0060H
 	CALL	002BH
 	CP	0DH
 	JR	Z,BACK
 	LD	A,'*'
 	LD	(HL),A
 	LD	BC,17FFH
 	CALL	0060H
 	CALL	002BH
 	CP	0DH
 	JR	Z,BACK
 	JR	FL1
 BACK	POP	BC
 	POP	HL
 	RET
 ;MESSAGES
 WMSG:	DEFM	'Hit "ENTER" to continue.'
 LMSG:	DEFL	$-WMSG
 DMSG:	DEFM	'Press "ENTER" for Directory.'
 DMLEN:	DEFL	$-DMSG
 OMSG:	DEFM	'DIR'
 	DEFB	0DH
 LENO:	DEFL	$-OMSG
 LREC:	DEFW	0
 REC	DEFW	0
 EOF	DEFB	0
 DCB:	DEFM	'MSG/PCL                         '
 BUFFER:	DEFS	256
 STORE	EQU	$
 	END	START
ry.'
 DMLEN:	DEFL	$-DMSG
 OMSG:	DEFM	'DIR'
